import { IField, IHTMLAttributes } from '../interfaces/ifield';
import { ICustomValidation } from '../interfaces/icustom-validation';
import { IValidator } from '../interfaces/ivalidator';
import { EventEmitter, OnInit } from '@angular/core';
import { FormGroup, FormBuilder, FormControl } from '@angular/forms';
import { FormService } from '../services/form.service';
import { TranslationService } from '../services/translation.service';
import * as i0 from "@angular/core";
export declare class BaseFieldComponent implements IField, OnInit {
    fb: FormBuilder;
    fs: FormService;
    ts: TranslationService;
    private readonly MSGerrors;
    name: string;
    value: string;
    placeholder: string;
    disabled: boolean;
    minLength: number;
    maxLength: number;
    min: number;
    max: number;
    required: boolean;
    form: FormGroup;
    control: FormControl;
    hintlabel: string;
    hint: string;
    tooltip: string;
    htmlType: string;
    iconBtn: string;
    iconAction: EventEmitter<any>;
    validators: IValidator;
    customValidation: ICustomValidation[];
    htmlAttribute: IHTMLAttributes;
    autocomplete: string;
    change: EventEmitter<any>;
    init: boolean;
    field: IField;
    constructor(fb: FormBuilder, fs: FormService, ts: TranslationService);
    get(): BaseFieldComponent;
    getErrorMeesage(): any;
    getMeesage(type: string, param: any): any;
    ngOnInit(): void;
    setUpConfig(config: IField): void;
    getValue(): any;
    getName(): string;
    synchronizeValidator(): void;
    getValidators(): IValidator;
    getFieldConfig(): IField;
    iconAct(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BaseFieldComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BaseFieldComponent, "app-base-field", never, { "name": "name"; "value": "value"; "placeholder": "placeholder"; "disabled": "disabled"; "minLength": "minLength"; "maxLength": "maxLength"; "min": "min"; "max": "max"; "required": "required"; "form": "form"; "control": "control"; "hintlabel": "hintlabel"; "hint": "hint"; "tooltip": "tooltip"; "htmlType": "htmlType"; "iconBtn": "iconBtn"; "iconAction": "iconAction"; "validators": "validators"; "customValidation": "customValidation"; "htmlAttribute": "htmlAttribute"; "autocomplete": "autocomplete"; "change": "change"; }, {}, never, never>;
}
