import { Router } from '@angular/router';
import { Observable } from 'rxjs';
import { DataStoreService } from './data-store.service';
import { UserService } from './user.service';
import * as i0 from "@angular/core";
export declare class AuthenticationService {
    private router;
    private userService;
    private dataStore;
    private _isLoggedIn;
    bla: string;
    private currentUser;
    private allowedActions;
    constructor(router: Router, userService: UserService, dataStore: DataStoreService);
    login(loginurl: string, username: string, password: string): Observable<any>;
    getUserProfile(url: string): void;
    logout(navigateToLoginpage: boolean, url: string): void;
    /**
     * Removes Authentication Informations from Localstorage
     * and navigates to the loginpage.
     */
    handleSessionTimeout(): void;
    /**
     * Checks currently only if the userProfile is stored locally
     * FIXME: An additional test for a valid cookie would be more useful.
     */
    checkIfUserIsAlreadyLoggedIn(): boolean;
    navigateToLoginPage(): void;
    loadUserProfile(): any;
    saveUserProfile(userProfile: any): void;
    get isLoggedIn(): boolean;
    set isLoggedIn(value: boolean);
    registerCurrentUser(): void;
    registerAllowedActions(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<AuthenticationService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<AuthenticationService>;
}
