import { FormGroup, FormControl, ValidatorFn, FormBuilder } from '@angular/forms';
import { IField } from '../interfaces/ifield';
import { IValidator } from '../interfaces/ivalidator';
import { BehaviorSubject } from 'rxjs';
import { BaseFieldComponent } from '../classes/field';
import { DialogService } from './dialog.service';
import { TranslatePipe } from './translation.pipe';
import * as i0 from "@angular/core";
export declare function difference(newObj: any, origObj: any): unknown;
export declare class FormService {
    private fb;
    private ds;
    private tp;
    forms: FormGroup;
    configs: any;
    changes: any;
    configChange: BehaviorSubject<any[]>;
    fieldchange: BehaviorSubject<any[]>;
    fields: any[];
    emptyObj: IField;
    constructor(fb: FormBuilder, ds: DialogService, tp: TranslatePipe);
    getFields(): any[];
    getFieldByName(name: string): BaseFieldComponent;
    addField(val: any): void;
    /**
     * @param form : FormGroup
     * @param name : FormName
     * @description adds form to Service of creates one
     */
    addForm(form: FormGroup, pageName: string): void;
    /**
     * @param config : { [ <PageName>: { <FormName>: { <FieldName>: IField } } ] }
     * @description adds Config to Service
     */
    addConfig(config: any): void;
    updateConfig(config: IField): void;
    updateControl(field: IField): void;
    /**
     * @param name : Page_Form_Field
     * @returns FieldConfig: IField
     */
    getConfigByName(name: string): IField;
    /**
     * @param field : IField
     * @returns FormControl
     */
    getFormControl(field: IField): FormControl;
    /**
     * @param name : Page_Form_Field
     * @returns Parent Form of key
     */
    getForm(name: string): FormGroup;
    /**
     * @param name : Name of Page
     * @returns Formgroup with forms of Page
     */
    getPage(name: string): FormGroup;
    getForms(): any;
    getConfigs(): any;
    /**
     * @param config : IValidator
     * @returns Array with ValidatorFunctions
     */
    buildValidators(config: IValidator): ValidatorFn[];
    /**
     * @param config : { [ <PageName>: { <FormName>: { <FieldName>: IField } } ] }
     * @description : FormGroup will be initalized and added by config [triggert in addConfig()]
     */
    setUp(config: any): void;
    buildCustomValidation(config: any): void;
    onConfigChange(): BehaviorSubject<any[]>;
    hasChanges(): unknown;
    resetForms(): void;
    resetControl(name: string): void;
    getControlChange(name: string): any;
    applieChanges(): void;
    update(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<FormService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<FormService>;
}
