import { HttpClient } from '@angular/common/http';
import { Observable, ReplaySubject } from 'rxjs';
import { DialogService } from './dialog.service';
import * as i0 from "@angular/core";
export declare class UserService {
    private http;
    private dialogService;
    private readonly headers;
    private options;
    apiBaseUrl: string;
    constructor(http: HttpClient, dialogService: DialogService);
    login(credentials: any, url: string): Observable<any>;
    logout(url: string): Observable<any>;
    /**
     * Gets current users profile.
     */
    getUserProfile(url: string): Observable<any>;
    /**
     * Get the allowed actions of the current user
     */
    getUserRoles(url: string): Observable<any>;
    /**
     * get all users
     */
    getUsers(url: string): Observable<any>;
    getUser(url: string, userId: number): Observable<any>;
    addUser(url: string, user: any): Observable<any>;
    addUserAndRoles(url: string, user: any): ReplaySubject<any>;
    editUser(url: string, user: any): Observable<any>;
    editUserAndRoles(url: string, user: any): Observable<any>;
    deleteUser(url: string, user: any): Observable<any>;
    updateRoles(url: string, user: any): Observable<Object>;
    static ɵfac: i0.ɵɵFactoryDeclaration<UserService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<UserService>;
}
