import { SelectionModel } from '@angular/cdk/collections';
import { AfterViewInit, EventEmitter, OnChanges, OnInit, SimpleChanges } from '@angular/core';
import { FormControl } from '@angular/forms';
import { MatTableDataSource } from '@angular/material/table';
import { MatDialog } from '@angular/material/dialog';
import { MatSort } from '@angular/material/sort';
import { MatPaginator } from '@angular/material/paginator';
import { TranslatePipe } from '../../services/translation.pipe';
import * as i0 from "@angular/core";
export declare enum TableType {
    USER = "USER",
    FILE = "FILE",
    GENERIC = "GENERIC"
}
export interface ITableViewOptions {
    type: TableType;
    searchable: boolean;
    showPaginator: boolean;
    showCheckbox: boolean;
    showActions: boolean;
    showCSVExport: boolean;
    csvName?: string;
    showDeleteAllButton?: boolean;
    dateStringToDateFilter?: string;
}
export interface ITableHeader {
    collumnName: string;
    collumnKey?: string;
    widthInPercentage?: number;
}
export declare class TableComponent implements OnInit, OnChanges, AfterViewInit {
    private dialog;
    private ts;
    selection: SelectionModel<any>;
    collumnsToBeDisplayed: string[];
    initialColumns: string[];
    dataSource: MatTableDataSource<any>;
    resultsLength: number;
    filterControl: FormControl;
    displayedColumns: ITableHeader[];
    viewOptions: ITableViewOptions;
    data: any[];
    paginator: MatPaginator;
    sort: MatSort;
    edit: EventEmitter<any>;
    download: EventEmitter<any>;
    delete: EventEmitter<any>;
    deleteBulk: EventEmitter<any>;
    constructor(dialog: MatDialog, ts: TranslatePipe);
    applyFilter(filterValue: string): void;
    /** Whether the number of selected elements matches the total number of rows. */
    isAllSelected(): boolean;
    /** Selects all rows if they are not all selected; otherwise clear selection. */
    masterToggle(): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onEdit(row: any): void;
    onDownload(row: any): void;
    onDeleteRecord(row: any): void;
    onDeleteSelectedRecords(): void;
    customFilterBasedOnDisplayColumns(data: any, filter: string): boolean;
    getDisplayData(colums: any): any[];
    getFilteredDisplayData(colums: any): any[];
    refresh(): void;
    csvExport(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TableComponent, "app-table", never, { "displayedColumns": "displayedColumns"; "viewOptions": "viewOptions"; "data": "data"; }, { "dataSource": "dataSource"; "edit": "edit"; "download": "download"; "delete": "delete"; "deleteBulk": "deleteBulk"; }, never, never>;
}
